# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2017_03_01
  module Models
    #
    # Object used to create an API Revision or Version based on an existing API
    # Revision
    #
    class ApiRevisionInfoContract

      include MsRestAzure

      # @return [String] Resource identifier of API to be used to create the
      # revision from.
      attr_accessor :source_api_id

      # @return [String] Version identifier for the new API Version.
      attr_accessor :api_version_name

      # @return [String] Description of new API Revision.
      attr_accessor :api_revision_description

      # @return [ApiVersionSetContractProperties] Version set details
      attr_accessor :api_version_set


      #
      # Mapper for ApiRevisionInfoContract class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApiRevisionInfoContract',
          type: {
            name: 'Composite',
            class_name: 'ApiRevisionInfoContract',
            model_properties: {
              source_api_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceApiId',
                type: {
                  name: 'String'
                }
              },
              api_version_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'apiVersionName',
                constraints: {
                  MaxLength: 100
                },
                type: {
                  name: 'String'
                }
              },
              api_revision_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'apiRevisionDescription',
                constraints: {
                  MaxLength: 256
                },
                type: {
                  name: 'String'
                }
              },
              api_version_set: {
                client_side_validation: true,
                required: false,
                serialized_name: 'apiVersionSet',
                type: {
                  name: 'Composite',
                  class_name: 'ApiVersionSetContractProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
